package pl.spjava.demospringboot.converters;

import pl.spjava.demospringboot.dto.PersonDTO;
import pl.spjava.demospringboot.dto.PersonUpdateCmdDTO;
import pl.spjava.demospringboot.entities.PersonEntity;

import java.util.List;
import java.util.Objects;
import java.util.stream.Collectors;

public class PersonConverter {
    public static PersonDTO fromPersonEntity(final PersonEntity personEntity) {
        return new PersonDTO(personEntity.getId(),
                personEntity.getLogin(),
                personEntity.getPassword(),
                personEntity.getEmail(),
                personEntity.getAge(),
                personEntity.isActive(),
                personEntity.getVersion());
    }

    public static PersonEntity fromPersonDTO(final PersonDTO personDTO) {
        return new PersonEntity( // you NEVER set id or version this way!
                personDTO.getLogin(),
                personDTO.getPassword(),
                personDTO.getEmail(),
                personDTO.getAge()
                // active has to be false by default
        );
    }

    public static List<PersonDTO> fromPersonEntities(List<PersonEntity> personEntities) {
        return null == personEntities ? null : personEntities.stream()
                .filter(Objects::nonNull)
                .map(PersonConverter::fromPersonEntity)
                .collect(Collectors.toList());
    }
}
