package pl.spjava.demospringboot.exceptions;

import org.springframework.http.HttpStatusCode;
import org.springframework.web.server.ResponseStatusException;

// This way all app exceptions are ResponseStatusException, so:
// 1. are automatically mapped to HTTP responses with status codes
// 2. are RuntimeException, so:
// 2.1. don't have to be declared (aren't checked)
// 2.2. @Transactional aspect by default rolls back a transaction if such exception is thrown by component method
public abstract class AppBaseException extends ResponseStatusException {
    protected AppBaseException(HttpStatusCode status, String reason) {
        super(status, reason);
    }

    protected AppBaseException(HttpStatusCode status, String reason, Throwable cause) {
        super(status, reason, cause);
    }
}
