package pl.spjava.demospringboot.repositories;

import jakarta.annotation.security.DenyAll;
import jakarta.annotation.security.PermitAll;
import jakarta.annotation.security.RolesAllowed;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.domain.Sort;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;
import pl.spjava.demospringboot.entities.PersonEntity;
import pl.spjava.demospringboot.interceptors.MethodCallLogged;

import java.util.List;
import java.util.Optional;
import java.util.UUID;

// This is real repository we're going to use with Person entities. (Almost) all methods needed are there already!

//It's not needed for the repository to be working. It's all about error handling!
//Try generating some errors ie. violate unique constraint with- and without @Repository
@Repository
@Transactional(propagation = Propagation.MANDATORY)
//@PreAuthorize("permitAll()") // You can effectively use it on repository interface, but only on class level
// Note that SpringData Repositories are brilliant, although they have their limitations
// Pointcuts and advices (--> interceptors) don't work within interfaces
// Method-level security can be applied only on class level, not methods (even if you override them explicitly)
// If you need these features, you have to implement your own repository concrete classes.

public interface PersonRepository extends AbstractRepository<PersonEntity>{
    // This is how we define new functionality. Spring data takes all the magic!
    PersonEntity findByLogin(String login);
}
